package bilancr;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Scanner;

public class SuborovaPolozkaDao implements PolozkaDao {

    @Override
    public void uloz(Polozka polozka) {
        File subor = new File("polozky.txt");
        try {            
            FileWriter fw = new FileWriter(subor, true);
            PrintWriter suborWriter = new PrintWriter(fw);
            suborWriter.println(polozka);
            suborWriter.close();
        } catch (FileNotFoundException e) {
            throw new UkladanieZlyhaloException("Subor sa nenasiel: " + subor, e);
        } catch (IOException e) {
            throw new UkladanieZlyhaloException("Ulozenie zlyhalo kvoli V/V chybe.", e);
        }
    }

    @Override
    public List<Polozka> dajVsetkyPolozky() {
        List<Polozka> polozky = new ArrayList<Polozka>();
        
        Scanner scanner = null;
        try {
            scanner = new Scanner(new File("polozky.txt"));  
            int cisloRiadka = 1;
            
            
            while(scanner.hasNextLine()) {
                
                System.out.println("Nacitavam riadok " + cisloRiadka);
                
                String riadok = scanner.nextLine();                
                String[] zlozky = riadok.split("\t");
                if(zlozky.length != 5) {
                    throw new ParsovaniePolozkyException(cisloRiadka, 5, zlozky.length);
                }
            
                Polozka polozka = new Polozka();
                //id, nazov, cena, cas_transakcie, kategoria
                if(!"null".equals(zlozky[0])) {
                    polozka.setId(Long.parseLong(zlozky[0]));
                }
                polozka.setNazov(zlozky[1]);
                polozka.setCena(new BigDecimal(zlozky[2]));
                polozka.setCasTransakcie(new Date(Long.parseLong(zlozky[3])));
                polozka.setKategoria(Kategoria.valueOf(zlozky[4]));
                
                polozky.add(polozka);
                
                cisloRiadka++;
            }
            
            return polozky;
        } catch (FileNotFoundException e) {
            throw new ParsovaniePolozkyException("Subor sa nenasiel: polozky.txt", e);
        } finally {
            if(scanner != null) {
                scanner.close();
            }
        }
    }
    
}
