package bilancr.gui;

import bilancr.Kategoria;
import bilancr.Polozka;
import bilancr.PolozkaDaoFactory;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import javax.swing.table.AbstractTableModel;

public class PolozkaTableModel extends AbstractTableModel { 
    public static final int POCET_STLPCOV = 2;

    private List<Polozka> polozky = new ArrayList<Polozka>();
    
    public PolozkaTableModel() {
        polozky.addAll(PolozkaDaoFactory.getPolozkaDao().dajVsetkyPolozky());
    }

    
    @Override
    public int getRowCount() {
        return polozky.size();
    }

    @Override
    public int getColumnCount() {
        return POCET_STLPCOV;
    }

    @Override
    public Object getValueAt(int row, int column) {
        Polozka polozka = polozky.get(row);
        if(column == 0) {
            return polozka.getNazov();
        }
        if(column == 1) {
            return polozka.getCena();
        } else {
            return "???";
        }
               
    }
    
}
